#ifndef __BG_H__
#define __BG_H__

//*****************************************************************************
// RtBM[V
// ǂeXg
#undef	USE_BATTERYFLAG		// obe̐Fւ%ł͂ȂBATTERYFLAGg

#include <windows.h>
#include <tchar.h>
#pragma warning(disable:4819)	// regext.h
#include <regext.h>
#pragma warning(default:4819)

#include "Collection.h"
#include "ShiftStatus.h"
#include "DataSetting.h"

//----------------------------------------------------------------------
// ^C}
#define ANI_UPDATE	   100	// Aj[V̍XVԊu
#define BAR_MINUPDATE	   100	// ŏXVԊu[ms]
#define BAR_UPDATE	   1000	// ̑̃o[Ot̍XVԊu[ms]
#define MEM_UPDATE	   1000	// o[Ot̍XVԊu[ms]
#define NET_MEASUREPERIOD  1000	// lbg[NgtBbNԊu[ms]
#define CPU_UPDATE	   250	// CPUL̍XVԊu[ms]
#define CPU_MEASUREPERIOD  1500	// CPUL̑Ԋu[ms]
// o[Ot̐ݒ
#define RFSTRENGTH_WIDTH   52	 // dEx̕
#define NETWORKMODE_WIDTH  52	 // ʐMԂ̕
#define SHIFTSTATUS_WIDTH  52	 // VtgXe[^X̕
#define MIN_FIXWIDTH	   10	 // ŏ
// o[Ot̉𑜓x
#define BARRESO		   1000

//----------------------------------------------------------------------
// 萔\
//
struct ColorInfo {
  COLORREF cFrameColor;		// gF
  COLORREF cBrushColor;		// OtF
  COLORREF cBlankColor;		// wiF
};
struct DrawTable {
  int	    cIndex;		// 臒lȂ
  ColorInfo cInfo;
};
struct RegEntry {
  HKEY hKey;
  LPCTSTR pszSubkey;
  LPCTSTR pszName;
};
struct RegInfo {
  LPARAM   lUserData;
  RegEntry sRegistry;
  DWORD	   dwMask;
};
struct BgEntry {
  LPCTSTR lpOptions;		// R}hCIvV()
  int nParam[MAXPARAMNUM];	// ftHgp[^
  int nMin[MAXPARAMNUM];	// p[^ŏl
  class Bg *(*fCreate)(HWND, UINT, const BgSetting &);	// ֐
};
//----------------------------------------------------------------------
// o[OtNX
//
class Bg {
  friend class BgShiftStatus;
 private:
  // lƂē
  UINT nUniqueID;		// UniqueID(1-)/EBhE
  int  nFixWidth;		// Œ蕝(0:ϕ)
  int  nLeft, nRight;		// o[Oẗ
  int  nWidth;			// o[Ot
  int  nHeight;			// o[Ot

 protected:
  // Ot`p
  const ColorInfo *pInfo;	// `悷F
  int nValue;			// o[Ot\p̒l(0-nResolution)
  // f[^WpNX
  DataCollection *pDC;
  // RXgN^(ڌďo֎~)
  Bg(UINT nUnique, int nHeightArg) {
    // Set member
    nUniqueID = nUnique;
    nHeight   = nHeightArg;
    // Initilize member
    pInfo     = NULL;
    nValue    = 0;
  }
  static int GetParameter(const BgEntry &pEntry, 
			  const BgSetting &pSetting, int num) {
    return ((pSetting.nParam[num]==0)?
	    (pEntry.nParam[num]):
	    (pSetting.nParam[num]<pEntry.nMin[num])?
	    (pEntry.nMin[num]):
	    (pSetting.nParam[num]));
  }
  int  GetUserMessageID() { return (WM_USER+nUniqueID-1); }
  int  GetUserTimerID()   { return nUniqueID; }
  void SetFixWidth(int nWidthArg = 0) { nFixWidth = nWidthArg; }
 public:
  virtual ~Bg() { };

  BOOL isFixWidth() { return (nFixWidth!=0); }
  int  GetFixWidth() { return nFixWidth; }
  int  SetGeometry(int nPos, int nWidthArg) {	// 擪ʒuƒ̎w
    nWidth = isFixWidth()?nFixWidth:nWidthArg;
    nLeft  = nPos;
    nPos  += nWidth;
    nRight = nPos++;
    return nPos;
  }
  int  SetGeometry(int nPos) {			// ŏIʒu̎w
    nRight = nPos;
    nWidth = nRight - nLeft;
    return nPos;
  }    
  // Ot̕`
  BOOL Draw(HWND hWnd) {
    BOOL bRet;
    HDC hdc = GetDC(hWnd);
    bRet = Draw(hdc);
    ReleaseDC(hWnd, hdc);
    return bRet;
  }
  virtual BOOL Draw(HDC hdc);
  // bZ[WnhO
  virtual BOOL MessageHandler(HWND hWnd,
			      UINT msg, WPARAM wParam, LPARAM lParam) {
    nValue = lParam;
    return TRUE;
  }
  // t@Ng֐
 private:
  static const BgEntry * const pEntryTbl[];
 public:
  static BOOL CheckOption(TCHAR tcOption);
  static Bg *Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
};
//----------------------------------------------------------------------
// ʐMx
//
class BgRF : public Bg {
 public:
  static const BgEntry pEntry;
 private:
  static const RegInfo   sRegInfo;
  static const DrawTable pInfoTbl[];
  HREGNOTIFY hNotify;
  int  nStrength;		// ݂̓dEx
  BOOL bVariWidth;		// xɉĕύX
  BgRF(HWND hWnd, UINT nUnique, const BgSetting &pSetting, DWORD dwData);
 public:
  ~BgRF();
  BOOL MessageHandler(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
  static BgRF *Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
};
typedef Bg *pBg;
//----------------------------------------------------------------------
// ʐM[h
//
#define NMWATCHREGNUM (6)
class BgNetMode : public Bg {
 public:
  static const BgEntry pEntry;
 private:
  static const RegInfo sRegInfoTbl[];
  static const ColorInfo *sModeTbl[];
  HREGNOTIFY hNotify[NMWATCHREGNUM];
  UINT  nMode;			// ݂̐ڑ[h
  UINT  nAnimate;		// Aj[VԊu(ڑ/_)
  BOOL  bDispMode;		// CWQ[^̕\[h(T:ڑ/F:_)
  BOOL  bMonitor;		// j^O̗L
  int   nCnt;			// j^OJE^
  HWND hWndSaved;
  BgNetMode(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
 public:
  ~BgNetMode();
  BOOL MessageHandler(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
  static BgNetMode *Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
};
//----------------------------------------------------------------------
// obe
//
class BgBattery : public Bg {
 public:
  static const BgEntry pEntry;
 private:
  static const DrawTable pInfoTbl[];
  BgBattery(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
 public:
  ~BgBattery() { delete pDC; }
  BOOL MessageHandler(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
  static BgBattery *Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
};
//----------------------------------------------------------------------
// gp
//
class BgMemory : public Bg {
 public:
  static const BgEntry pEntry;
 private:
  static const ColorInfo pColor;
  int nStatus;
  BgMemory(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
 public:
  ~BgMemory() { delete pDC; }
  static BgMemory *Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
};
//----------------------------------------------------------------------
// CPUgp
//
class BgCPU : public Bg {
 public:
  static const BgEntry pEntry;
 private:
  static const ColorInfo pColor;
  BgCPU(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
 public:
  ~BgCPU() { delete pDC; }
  static BgCPU *Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
};
//----------------------------------------------------------------------
// Xg[Wgp
//
class BgStorage : public Bg {
 public:
  static const BgEntry pEntry;
 private:
  static const ColorInfo pColor;
  TCHAR StoragePath[32];
  BgStorage(HWND hWnd, UINT nUnique, const BgSetting &pSetting, LPCTSTR);
 public:
  ~BgStorage() { delete pDC; }
  static BgStorage *Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
};
//----------------------------------------------------------------------
// ʐM
//
class BgTraffic : public Bg {
 public:
  static const BgEntry pEntry;
 private:
  static const DrawTable pInfoTbl[];
#if 0
  int  nStatus;
#endif
  HWND hWndSaved;
  FIFO *fData;
  BgTraffic(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
 public:
  ~BgTraffic();
  BOOL MessageHandler(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
  static BgTraffic *Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
};
//----------------------------------------------------------------------
// VtgL[Xe[^X
//
class BgShiftStatus : public Bg {
 public:
  static const BgEntry pEntry;
 private:
  static const ColorInfo pColorTbl[];
  ShiftStatus *pSS;
  BgShiftStatus(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
 public:
  ~BgShiftStatus() { delete pSS; }
  BOOL Draw(HDC hdc);
  static Bg *Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
};
#if 0
//----------------------------------------------------------------------
// VKɃNXƂ̃ev[g
//
class Bg : public Bg {
 public:
  static const BgEntry pEntry;
 private:
  static const DrawTable pInfoTbl[];
  Bg(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
  ShiftStatus *pSS;
 public:
  ~Bg();
  BOOL MessageHandler(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
  static Bg *Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting);
};
const BgEntry   Bg::pEntry = { };
const DrawTable Bg::pInfoTbl[] = {
};
Bg::Bg(HWND hWnd, UINT nUnique, const BgSetting &pSetting) :
  Bg(nUnique, pSetting.nHeight)
{
}
Bg::~Bg()
{
  delete pDC;
}
Bg *Bg::Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting)
{
  return new Bg(hWnd, nUnique, pSetting);
}
BOOL Bg::MessageHandler(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
}
#endif
#endif
